-- utility v0.1
-- free to modify/reuse

----------------------------
--        Keriz           --
----------------------------



-- Crafts recipes
   --Bench

minetest.register_craft({
	output = 'utility:bench',
	recipe = {
		  { 'default:wood','default:wood', 'default:wood'},
                  { 'default:wood', '', 'default:wood'},
	}
})

   --Fridge

minetest.register_craft({
	output = 'utility:fridge',
	recipe = {
                 -- { 'default:steel_ingot', 'default:steel_ingot', 'wood'},
                -- { 'default:steel_ingot', 'default:stick', ''},
                  { 'default:steel_ingot', 'default:steel_ingot'},
                  { 'default:steel_ingot', 'default:stick'},
                  { 'default:steel_ingot', 'default:steel_ingot'},
	}
})


--------------------------------------------------------------------------------

-- Block
   --Bench

minetest.register_node("utility:bench", {
	description = 'Bench',
	tiles = {
		"bench.png",
	},
	drawtype = "nodebox",
	sunlight_propagates = true,
	paramtype = 'light',
	paramtype2 = "facedir",
	node_box = {
		type = "fixed",
		fixed = {
			{-0.4,0,-0.5, 0.4,0.2,0.5},
			{-0.1,-0.5,0.2, 0.1,0,0.4},
			{-0.1,-0.5,-0.4, 0.1,0,-0.2},
		},
	},
	groups = {snappy=2,choppy=2,oddly_breakable_by_hand=2},
})

    --Fridge


minetest.register_node( 'utility:fridge', {
        description         = 'Fridge',
        drawtype            = 'signlike',
        tile_images         = { 'fridge.png' },
        inventory_image     = 'fridge.png',
        wield_image         = 'fridge.png',
        paramtype2          = 'wallmounted',
        selection_box       = { type = 'wallmounted' },
        groups              = { choppy=2, dig_immediate=2 },
})


minetest.register_node( "utility:fridge_top", {
        Description         = 'Top fridge',
        tiles = {
		"fridge_normal.png",
                "fridge_normal.png",
                "fridge_top2.png",
                "fridge_top2.png",
                "fridge_top.png",
                "fridge_top2.png",

	},
        drawtype = "nodebox",
        sunlight_propagates = true,
        paramtype           = 'light',
        paramtype2          = "facedir",
        node_box = {
		type = "fixed",
		fixed = {
			{-0.5,-0.5,-0.5, 0.5,0.5,0.3}, --base top
			{0.2,0.4,0.4, 0.3,0.1,0.4},  -- poignet
			{0.2,0.4,0.3, 0.3,0.4,0.4},  -- manche haut
                        {0.2,0.1,0.3, 0.3,0.1,0.4},  -- manche bas
		},
	},
        drop                = 'utility:fridge',
        groups = {snappy=2,choppy=2,oddly_breakable_by_hand=2},
})

minetest.register_node("utility:fridge_bottom", {
        Description         = 'Bottom fridge',
        tiles = {
		"fridge_normal.png",
                "fridge_normal.png",
                "fridge_bottom2.png",
                "fridge_bottom2.png",
                "fridge_bottom.png",
                "fridge_bottom2.png",
	},
        drawtype            = "nodebox",
        sunlight_propagates = true,
        paramtype           = 'light',
        paramtype2          = "facedir",
        node_box = {
		type = "fixed",
		fixed = {
			{-0.5,-0.5,-0.5, 0.5,0.5,0.3}, --base bottom
		},
	},
        drop                = 'utility:fridge',
        groups = {snappy=2,choppy=2,oddly_breakable_by_hand=2}
})

---------------------------------------------------------------------

--Function
  --Global
local round = function( n )
        if n >= 0 then
                return math.floor( n + 0.5 )
        else
                return math.ceil( n - 0.5 )
        end
end

  --Fridge
local on_fridge_placed = function( pos, node, placer )
        if node.name ~= 'utility:fridge' then return end

        upos = { x = pos.x, y = pos.y - 1, z = pos.z }
        apos = { x = pos.x, y = pos.y + 1, z = pos.z }
        und = minetest.env:get_node( upos )
        abv = minetest.env:get_node( apos )

        dir = placer:get_look_dir()

        if und.name == 'air' then
                minetest.env:add_node( pos,  { name = 'utility:fridge_top', param2 = newparam } )
                minetest.env:add_node( upos, { name = 'utility:fridge_bottom', param2 = newparam } )
        elseif abv.name == 'air' then
                minetest.env:add_node( pos,  { name = 'utility:fridge_bottom', param2 = newparam } )
                minetest.env:add_node( apos, { name = 'utility:fridge_top', param2 = newparam } )
        else
                minetest.env:remove_node( pos )
                placer:get_inventory():add_item( "main", 'utility:fridge' )
                minetest.chat_send_player( placer:get_player_name(), 'not enough space' )
        end
end

local on_fridge_digged = function(pos, node, digger )

         upos = { x = pos.x, y = pos.y - 1, z = pos.z }
         apos = { x = pos.x, y = pos.y + 1, z = pos.z }

        if (node.name == 'utility:fridge_top' ) then
           minetest.env:remove_node(upos)
        
        elseif (node.name == 'utility:fridge_bottom' ) then
           minetest.env:remove_node(apos)
        end

end

--------------------------------------------------------------------------

--minetest integration function
minetest.register_on_placenode( on_fridge_placed )
minetest.register_on_dignode( on_fridge_digged )
